SWAPON(8)

NUME
swapon, swapoff - activează/dezactivează dispozitive și fișiere pentru paginare și zone de interschimb

REZUMAT

swapon [opțiuni] [fișier-special...]

swapoff [-va] [fișier-special...]

DESCRIERE

swapon este utilizat pentru a specifica dispozitivele pe care trebuie să aibă loc paginarea și interschimbul.

Dispozitivul sau fișierul utilizat este dat de parametrul fișier-special. Acesta poate fi de forma -L eticheta sau -U uuid pentru a indica un dispozitiv prin etichetă sau uuid.

Apelurile către swapon au loc în mod normal în scripturile de pornire ale sistemului, făcând disponibile toate dispozitivele de spațiu de interschimb, astfel încât activitatea de paginare și de interschimb este repartizată între mai multe dispozitive și fișiere.

swapoff dezactivează zona de interschimb pe dispozitivele și fișierele specificate. Atunci când se indică opțiunea -a, zona de interschimb este dezactivată pe toate dispozitivele și fișierele de spațiu de interschimb cunoscute (așa cum se găsesc în /proc/swaps sau /etc/fstab).

OPȚIUNI

-a, --all
    Toate dispozitivele marcate ca „swap” în fișierul /etc/fstab sunt făcute disponibile, cu excepția celor care au opțiunea „noauto”. Dispozitivele care sunt deja utilizate ca spațiu de interschimb sunt omise în mod silențios. Consultați secțiunea CONFIGURAREA FSTAB pentru mai multe detalii.

-T, --fstab ruta
    Specifică un fișier fstab alternativ pentru compatibilitate cu mount(8). Dacă ruta este un director, atunci fișierele din director sunt sortate de strverscmp(3); fișierele care încep cu "." sau care nu au extensia .fstab sunt ignorate. Opțiunea poate fi specificată de mai multe ori. Această opțiune este concepută în principal pentru scripturile initramfs sau chroot în care se specifică o configurație suplimentară față de configurația standard a sistemului.

-d, --discard[=politica]
    Activează eliminările spațiului de interschimb, dacă dispozitivul pe care se află spațiul de interschimb acceptă operația de eliminare sau de tăiere. Acest lucru poate îmbunătăți performanțele pe unele dispozitive cu stare solidă (SSD), dar de multe ori nu are efect. Opțiunea permite selectarea între două politici disponibile de eliminare a spațiului de interschimb:

    --discard=once
        pentru a efectua o singură operație de renunțare pentru întregul spațiu de interschimb (swap) la lansarea «swapon»; sau

    --discard=pages
        pentru a elimina în mod asincron paginile spațiului de interschimb eliberate, înainte ca acestea să fie disponibile pentru reutilizare.

    Dacă nu este selectată nicio politică, comportamentul implicit este de a activa ambele tipuri de eliminare. Opțiunile de montare /etc/fstab discard, discard=once sau discard=pages pot fi, de asemenea, utilizate pentru a activa fanioanele de „discard” (eliminare)

-e, --ifexists
    Ignoră în mod silențios dispozitivele care nu există. Opțiunea de montare /etc/fstab nofail poate fi, de asemenea, utilizată pentru a ignora un dispozitiv inexistent.

-f, --fixpgsz
    Reinițializează (execută mkswap) spațiul de interschimb dacă dimensiunea paginii sale nu corespunde cu cea a nucleului care rulează în prezent. mkswap(8) inițializează întregul dispozitiv și nu verifică dacă există blocuri defecte.

-L eticheta
    Folosește partiția care are eticheta specificată. (Pentru aceasta, este necesar accesul la /proc/partitions.)

-o, --options argumente-opționale
    Specificați opțiunile de zonei de interschimb printr-un șir de caractere compatibil cu fstab, separat prin virgule. De exemplu:

    swapon -o pri=1,discard=pages,nofail /dev/sda2

    Șirul opts este evaluat ultimul și prevalează asupra tuturor celorlalte opțiuni din linia de comandă.

-p, --priority prioritatea
    Specifică prioritatea dispozitivului spațiului de interschimb. prioritatea este o valoare cuprinsă între 0 și 32767. Un număr mai mare indică o prioritate mai mare. Consultați swapon(2) pentru o descriere completă a priorităților spațiului de interschimb. Adăugați pri=valoare la câmpul de opțiuni din /etc/fstab pentru utilizarea cu swapon -a. Atunci când nu se definește nicio prioritate, nucleul Linux utilizează în mod implicit numere negative.

-s, --summary
    Afișează rezumatul utilizării spațiului de interschimb pe dispozitiv. Echivalent cu cat /proc/swaps. Acest format de ieșire este DEPRECIAT în favoarea --show, care oferă un control mai bun asupra datelor de ieșire.

--show[=coloana...]
    Afișează un tabel definibil de spații de interschimb. Consultați --help pentru o listă a coloanelor disponibile.

--output-all
    Afișează toate coloanele disponibile.

--annotate[=când]
    Adaugă o adnotare la numele fiecărui antet de coloană. O astfel de adnotare poate fi afișată sub formă de ferestre emergente de către terminalele care acceptă această funcție. Argumentul opțional când poate fi always (întotdeauna), never (niciodată) sau auto. Dacă argumentul este omis, valoarea implicită este auto, ceea ce înseamnă că adnotările vor fi utilizate doar atunci când ieșirea se face către un terminal.

--noheadings
    Nu afișează titlurile atunci când afișează ieșirea --show.

--raw
    Afișează ieșirea --show fără a alinia coloanele tabelului.

--bytes
    Afișează dimensiunea spațiului de interschimb în octeți în --show în loc de unități ușor de interpretat.

-U uuid
    Utilizează partiția care are uuid-ul specificat.

-v, --verbose
    Oferă informații detaliate la ieșire.

-h, --help
    Afișează acest mesaj de ajutor și iese.

-V, --version
    Afișează versiunea și iese.

CONFIGURAREA FSTAB

Comanda swapon --all citește configurația din fișierul /etc/fstab (sau dintr-un fișier specificat prin opțiunea de linie de comandă --fstab). Sunt relevante doar intrările din fstab pentru care tipul sistemului de fișiere (al treilea câmp) este stabilit la „swap”.

Opțiunea --options acceptă valori în același format ca cel care poate fi specificat în al patrulea câmp din fișierul fstab.

  Primul câmp (sursa)

Specifică sursa spațiului de interschimb. Dacă sursa este un fișier obișnuit, aceasta este indicată printr-o rută absolută.

Dacă spațiul de interschimb este un dispozitiv de blocuri, acesta poate fi identificat prin ruta dispozitivului, prin etichetele zonei de interschimb LABEL= sau UUID= (consultați mkswap(8) pentru mai multe detalii) sau prin etichetele partiției, cum ar fi PARTLABEL= sau PARTUUID=.

  Al doilea câmp (ținta)

Neutilizat de swapon, se recomandă utilizarea valorii „none”.

  Al treilea câmp (tipul)

Necesită „swap” ca tip de sistem de fișiere.

  Al patrulea câmp (opțiuni).

Acesta este formatat ca o listă de opțiuni separate prin virgule. Toate opțiunile necunoscute sunt ignorate în mod silențios. Dacă opțiunile nu sunt necesare, se recomandă utilizarea termenului „defaults”. Opțiunile specificate în fstab completează sau suprascriu parametrii specificați în linia de comandă swapon.

Opțiunile swap acceptate sunt:

noauto
    Ignoră această intrare atunci când se execută comanda swapon --all.

nofail
    Nu raportează erori pentru acest dispozitiv dacă acesta nu există.

--discard[=politica]
    Activează eliminarea paginilor din memoria swap. Opțiunile acceptate sunt discard, discard=once sau discard=pages. Pentru mai multe detalii, consultați opțiunea de linie de comandă --discard.

pri=prioritatea
    Specifică prioritatea dispozitivului swap. Pentru mai multe detalii, consultați opțiunea de linie de comandă --priority.

  Al cincilea câmp

Neutilizat de swapon, se recomandă să rămână gol.

  Al șaselea câmp

Neutilizat de swapon, se recomandă să rămână gol.

STARE DE IEȘIRE

swapoff are următoarele valori de stare de ieșire începând cu v2.36:

0
    succes

2
    sistemul nu are suficientă memorie pentru a opri operațiile din spațiul de interschimb (OOM)

4
    apelul de sistem swapoff(2) a eșuat din alt motiv

8
    eroare de sistem care nu se bazează pe apelul de sistem swapoff(2) (memorie epuizată, ...)

16
    eroare de utilizare sau de sintaxă

32
    toate apelurile «swapoff» au eșuat pentru --all

64
    unele apeluri «swapoff» au reușit pentru --all

Comanda swapoff --all returnează 0 (toate au reușit), 32 (toate au eșuat) sau 64 (unele au eșuat, altele au reușit).

+ Versiunile vechi, înainte de v2.36, nu au o stare de ieșire documentată, 0 înseamnă succes în toate versiunile.

MEDIU

LIBMOUNT_DEBUG=all
    activează ieșirea de depanare a libmount.

LIBBLKID_DEBUG=all
    activează ieșirea de depanare a libblkid.

FIȘIERE

/dev/sd??
    dispozitive standard de paginare

/etc/fstab
    tabel de descriere a sistemului de fișiere ascii

NOTE

  Fișiere cu găuri

Implementarea fișierului spațiului de interschimb din nucleu se așteaptă să poată scrie direct în fișier, fără ajutorul sistemului de fișiere. Aceasta este o problemă în cazul fișierelor cu găuri sau al fișierelor cu copiere-la-scriere pe sisteme de fișiere precum Btrfs.

Comenzi precum cp(1) sau truncate(1) creează fișiere cu găuri. Aceste fișiere vor fi respinse de swapon.

Fișierele prealocate create de fallocate(1) pot fi interpretate ca fișiere cu găuri, în funcție de sistemul de fișiere. Fișierele de spațiu de interschimb prealocate sunt acceptate pe XFS începând cu Linux 4.18.

Cea mai portabilă soluție pentru a crea un fișier de spațiu de interschimb este să folosiți dd(1) și /dev/zero.

  Btrfs

Fișierele de spațiu de interschimb pe Btrfs sunt acceptate începând cu Linux 5.0 pe fișiere cu atributul nocow. Consultați pagina de manual btrfs(5) pentru mai multe detalii.

Începând cu versiunea 2.41, comanda mkswap --file poate crea un nou fișier de spațiu de interschimb (swap) cu atributul nocow.

  NFS

Este posibil ca spațiul de interschimb pe NFS să nu funcționeze.

  Suspendare

swapon detectează automat și rescrie o semnătură de spațiu de interschimb cu date de suspendare de software vechi (de exemplu, S1SUSPEND, S2SUSPEND, ...). Problema este că, dacă nu se procedează astfel, atunci avem parte de o corupție a datelor la următoarea încercare de dezactivare a suspendării.

ISTORIC

Comanda swapon a apărut în 4.0BSD.

CONSULTAȚI ȘI

swapoff(2), swapon(2), fstab(5), init(8), fallocate(1), mkswap(8), mount(8), rc(8)

RAPORTAREA ERORILOR

Pentru rapoarte de eroare, folosiți

DISPONIBILITATE

Comanda swapon face parte din pachetul util-linux care poate fi descărcat de la